﻿using Kendo.Mvc.Extensions;
using Kendo.Mvc.UI;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using TelerikMvcAppDropDownListVirtual.Models;

namespace TelerikMvcAppDropDownListVirtual.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            ViewBag.Message = "Welcome to ASP.NET MVC!";

            return View();
        }       

        public ActionResult Virtualization_Read([DataSourceRequest] DataSourceRequest request, string firstName, string lastName)
        {
            return Json(GetProducts().ToDataSourceResult(request));
        }

        public ActionResult Orders_ValueMapper(int[] values)
        {
            var indices = new List<int>();

            if (values != null && values.Any())
            {
                var index = 0;

                foreach (var product in GetProducts())
                {
                    if (values.Contains(product.ProductId))
                    {
                        indices.Add(index);
                    }

                    index += 1;
                }
            }

            return Json(indices, JsonRequestBehavior.AllowGet);
        }

        public IEnumerable<Product> GetProducts()
        {
            var products = Enumerable.Range(0, 4000).Select(i => new Product
            {
                ProductId = i,
                ProductName = "ProductName " + i,
                ProductDescription = "asdasuidh asuioduoasuiuydh asoidu aos8du aosiduaosiudasoidu aoisdu aoidu asoiduasopdiuasoidu aodaosdi uodi qwuopdiqwudoiqwudoiqwudp[qiwu d uqiduwqp fwerif erg wsf sef ser fwef fwefwe "
            });

            return products;
        }
    }
}
